// Ex03.java

package ch.aplu.tut;

import ch.aplu.android.*;
import ch.aplu.tcp.*;
import ch.aplu.util.Monitor;

public class Ex03 extends GameGrid 
  implements TcpNodeListener
{
  private final String sessionID = "xyz&123";
  private final String nickname = "omega";
  private GGConsole c;
  
  public void main()
  {
    c = GGConsole.init();
    TcpNode tcpNode = new TcpNode();
    tcpNode.addTcpNodeListener(this);
    c.println("Trying to connect to " + tcpNode.getRelay()); 
    c.println("using port " + tcpNode.getPort());
    c.println("SessionID: " + sessionID);
    c.println("Nickname: " + nickname);
    tcpNode.connect(sessionID, nickname, 2, 2, 2);
    Monitor.putSleep();
    tcpNode.sendRelayRequest(TcpNode.GET_PERSONAL_NODE);
    tcpNode.sendRelayRequest(TcpNode.GET_SERVER_STATUS);
  }

  public void nodeStateChanged(TcpNodeState state)
  {
    switch (state)
    {
      case DISCONNECTED:
        c.println("State changed: DISCONNECTED");
        break;
      case CONNECTING:
        c.println("State changed: CONNECTING");
        break;
      case CONNECTED:
        c.println("State changed: CONNECTED");
        Monitor.wakeUp();
        break;
    }
  }

  public void messageReceived(String sender, String text)
  {
    c.println("Message from " + sender + ": " + text);
  }

  public void statusReceived(String text)
  {
    c.println("Status: " + text);
  }
}


