// Ex09.java
// App for class Tennisball2

package ch.aplu.tut;

import ch.aplu.android.*;
import android.graphics.*;
import java.text.DecimalFormat;

public class Ex09b extends GameGrid implements GGFlingListener
{
  private final double courtWidth = 23.77; // m
  private double dimFactor;
  private final double vFactor = 50.0; 
  private GGStatusBar status;
  protected static GGComboSensor sensor;
  
  public Ex09b()
  {
    super(WHITE, false, true, null);  // full screen, white boarder
    setScreenOrientation(LANDSCAPE);
    status = addStatusBar(20);
  }

  public void main()
  {
    getBg().clear(Color.rgb(70, 90, 40));
    addFlingListener(this);
    dimFactor = getNbHorzCells() / courtWidth;
    setSimulationPeriod(25);
    sensor = GGComboSensor.init(this);
    doRun();
    status.setText("Fling the ball!");
  }

  public boolean flingEvent(Point start, Point end, GGVector velocity)
  {
    TennisBall2 tennisBall = 
      new TennisBall2(velocity.mult(vFactor), dimFactor);
    DecimalFormat d = new DecimalFormat("#.##");
    String vx = d.format(velocity.x);
    String vy = d.format(velocity.y);
    String v = d.format(velocity.magnitude());
    status.setText("(vx, vy) = (" + vx + ", " + vy + "); v = " + v);
    addActorNoRefresh(tennisBall, new Location(end.x, end.y));
    return true;
  }

}
