// Ex11.java

package ch.aplu.tut;

import ch.aplu.android.*;
import android.graphics.*;
import java.util.Date;

public class Ex11 extends GameGrid 
  implements GGActorTouchListener
{
  private long accTime = 0;
  
  private class Alien extends Actor
  {
    private long birthTime;
  
    public Alien()
    {
      super(true, "alien");
      birthTime = new Date().getTime();
    }
    
    public void act()
    {
      move();
      if (!isInGrid())
      {
        removeSelf();
        accTime += getLifeTime();
      }
    }
    
    public long getLifeTime()
    {
      return new Date().getTime() - birthTime;
    }
  }
  
  private GGStatusBar status;

  public Ex11()
  {
    super(true, windowZoom(500));
    status = addStatusBar(30);
  }

  public void main()
  {
    getBg().clear(Color.rgb(0, 0, 100));
    doRun();
    setSimulationPeriod(50);
    for (int i = 0; i < 40; i++)
    {
      Alien alien = new Alien();
      addActorNoRefresh(alien, getRandomLocation(), 
        getRandomDirection());
      alien.addActorTouchListener(this, GGTouch.press, false);
      delay(500);
    }
    setTouchEnabled(false);
    status.setText(
      String.format("Game over! Life time: %5.1f s", 
      accTime / 1000.0));
    doPause();
    refresh();
  }

  public void actorTouched(Actor actor, GGTouch touch, 
    Point spot)
  {
    accTime += ((Alien)actor).getLifeTime();
    actor.removeSelf();
  }
  
  public void act()
  {
    int nb = getNumberOfActors(Alien.class);    
    status.setText(
      String.format("# Aliens: %3d - Life time: %5.1f s",
      nb, accTime / 1000.0));
  }
} 

