// Ex14.java
// Rubber band rectangle

package ch.aplu.tut;

import ch.aplu.android.*;

public class Ex14 extends GameGrid implements GGTouchListener
{
  private GGStatusBar status;
  private int xStart;
  private int yStart;
  private int xEnd;
  private int yEnd;

  public Ex14()
  {
    super("reef", windowZoom(500));
    status = addStatusBar(30);
  }

  public void main()
  {
    status.setText("Press and Drag");
    refresh();
    addTouchListener(this, GGTouch.press | GGTouch.drag | GGTouch.release);
    getBg().setPaintColor(YELLOW);
    getBg().setLineWidth(4);
  }

  public boolean touchEvent(GGTouch touch)
  {
    if (touch.getEvent() == GGTouch.press)
    {
      xStart = xEnd = touch.getX();
      yStart = yEnd = touch.getY();
      getBg().setXORMode();
    }
    if (touch.getEvent() == GGTouch.drag)
    {
      getBg().drawRectangle(xStart, yStart, xEnd, yEnd);
      xEnd = touch.getX();
      yEnd = touch.getY();
      getBg().drawRectangle(xStart, yStart, xEnd, yEnd);
      refresh();
    }
    if (touch.getEvent() == GGTouch.release)
    {
      getBg().setPaintMode();
      xEnd = touch.getX();
      yEnd = touch.getY();
      getBg().drawRectangle(xStart, yStart, xEnd, yEnd);
      status.setText(String.format("from (%3d, %3d) to (%3d, %3d)",
        xStart, yStart, xEnd, yEnd));
      refresh();
    }
    return true;
  }
}
