// Tennisball.java

package ch.aplu.tut;

import ch.aplu.android.*;

public class TennisBall extends Actor
{
  private final double g = 9.81; // in m/s^2
  private double dimFactor;
  private double x, y;  // in m 
  private double vx, vy; // in  m/s
  private double dt;  // in s

  public TennisBall(double vx, double vy, double dimFactor)
  {
    super("tennisball");
    // Initial condition
    this.vx = vx;
    this.vy = vy; 
    this.dimFactor = dimFactor;
  }
  
  public void reset()
  {
    // Initial condition
    x = getX() / dimFactor;
    y = getY() / dimFactor;
    dt = gameGrid.getSimulationPeriod() / 1000.0;  // in s
  }
  
  public void act()
  {
    vy = vy + g * dt;
    x = x + vx * dt;
    y = y + vy * dt;
    setLocation(new Location(dimFactor * x, dimFactor * y));
    if (!isInGrid())
      removeSelf();
  }
}
