// CardEx04.java
// Deal-out single cards

package ch.aplu.cardex04;

import android.graphics.Color;
import ch.aplu.jcardgame.*;
import ch.aplu.android.*;

public class CardEx04 extends CardGame
{
  public enum Suit
  {
    SPADES, HEARTS, DIAMONDS, CLUBS
  }

  public enum Rank
  {
    ACE, KING, QUEEN, JACK, TEN
  }
  //
  private Deck deck;
  private final int nbPlayers = 4;
  private final Location[] handLocations =
  {
    new Location(300, 525),
    new Location(75, 300),
    new Location(300, 75),
    new Location(525, 300),
    new Location(300, 300)
  };
  private Hand[] hands;
  private Hand talon;

  public CardEx04()
  {
    super(Color.rgb(20, 80, 0),  Color.WHITE, BoardType.HORZ_SQUARE, windowZoom(600)); 
  }
  
  public void main()
  {
    deck = new Deck(Suit.values(), Rank.values(), "cover");
    dealingOut();
    showToast("Dealing out...done.");
  }

  private void dealingOut()
  {
    showToast("Dealing out...");
  
    hands = deck.dealingOut(nbPlayers, 0);  // All cards in talon
    talon = hands[nbPlayers];

    for (int i = 0; i < nbPlayers; i++)
    {
      hands[i].setView(this, new RowLayout(handLocations[i], 300, 90 * i));
      hands[i].draw();  // Must draw even if empty it to set the hand location
      hands[i].setTouchEnabled(true);
    }

    talon.setView(this, new StackLayout(handLocations[nbPlayers]));
    talon.draw();

    while (!talon.isEmpty())
    {
      for (int i = 0; i < nbPlayers; i++)
      {
        Card top = talon.getLast();
        talon.transfer(top, hands[i], false); // Don't show to avoid flickering
        hands[i].sort(Hand.SortType.RANKPRIORITY, true);
      }
    }
  }

}