// CardEx05.java
// Dealing out in batches

package ch.aplu.cardex05;

import ch.aplu.jcardgame.*;
import ch.aplu.android.*;
import android.graphics.Color;

public class CardEx05 extends CardGame
{
  public enum Suit
  {
    SPADES, HEARTS, DIAMONDS, CLUBS
  }

  public enum Rank
  {
    ACE, KING, QUEEN, JACK, TEN, NEUN, EIGHT, SEVEN, SIX
  }
  //
  private Deck deck;
  private final int nbPlayers = 4;
  private final Location[] handLocations =
  {
    new Location(300, 525),
    new Location(75, 300),
    new Location(300, 75),
    new Location(525, 300),
  };
  private final Location talonLocation = new Location(300, 300);
  private final int batchSize = 3;
  private Hand[] hands;
  private Hand talon;

  public CardEx05()
  {
     super(Color.rgb(20, 80, 0), Color.WHITE, BoardType.HORZ_SQUARE, windowZoom(600)); 
  }
  
  public void main()
  {
    deck = new Deck(Suit.values(), Rank.values(), "cover");
    dealingOut();
    showToast("Dealing out...done.");
  }

  private void dealingOut()
  {
    showToast("Dealing out in batches...");

    hands = deck.dealingOut(nbPlayers, 0);  // All cards in shuffled talon
    talon = hands[nbPlayers];

    for (int i = 0; i < nbPlayers; i++)
    {
      hands[i].setView(this, new RowLayout(handLocations[i], 300, 90 * i));
      hands[i].draw();
    }

    CardCover talonCover = new CardCover(this, talonLocation, deck, 1, 0);

    while (!talon.isEmpty())
    {
      for (int i = 0; i < nbPlayers; i++)
      {
        for (int k = 0; k < batchSize; k++)
        {
          hands[i].insert(talon.getLast(), false);
          talon.removeLast(false);
        }
        if (talon.isEmpty())
          talonCover.removeSelf();
        CardCover cardCover = new CardCover(this, talonLocation, deck, 1, 0);
        cardCover.slideToTarget(handLocations[i], 20, true, true);
        cardCover.removeSelf();
        if (i == 0)
        {
          hands[i].setVerso(false);
          hands[i].sort(Hand.SortType.RANKPRIORITY, false);
        }
        else
          hands[i].setVerso(true);
        hands[i].draw();
      }
    }
    hands[0].setTouchEnabled(true);
  }
 
}