// CardEx08.java
// Cut a deck

package ch.aplu.cardex08;

import ch.aplu.jcardgame.*;
import ch.aplu.android.*;
import android.graphics.Color;

public class CardEx08 extends CardGame
{
  public enum Suit
  {
    SPADES, HEARTS, DIAMONDS, CLUBS
  }

  public enum Rank
  {
    ACE, KING, QUEEN, JACK, TEN, NINE, EIGHT, SEVEN, SIX
  }

  private Deck deck;
  private Hand hand;

  public CardEx08()
  {
    super(Color.rgb(20, 80, 0), Color.WHITE, BoardType.HORZ_SQUARE, windowZoom(600)); 
  }

  public void main()
  {
    deck = new Deck(Suit.values(), Rank.values(), "cover");
    hand = deck.dealingOut(1, 5, false)[0];
    hand.setView(this, new RowLayout(new Location(150, 80), 290));
    hand.setTouchEnabled(true);
    hand.draw();
    initToolBar();
  }

  private void initToolBar()
  {
    final ToolBarStack numbers =
      new ToolBarStack("number30", 10);
    ToolBarSeparator separator =
      new ToolBarSeparator(2, 30, Color.BLACK);
    final ToolBarItem cutBtn =
      new ToolBarItem("cutbtn", 2);
    ToolBar toolBar = new ToolBar(this);
    toolBar.addItem(numbers, separator, cutBtn);
    toolBar.add(new Location(7, 160).toReal());

    toolBar.addToolBarListener(new ToolBarAdapter()
    {
      public void pressed(ToolBarItem item)
      {
        if (item == cutBtn)
        {
          cutBtn.show(1);
          hand.cut(numbers.getItemId(), true);
        }
        else
          ((ToolBarStack)item).showNext();
      }

      public void released(ToolBarItem item)
      {
        if (item == cutBtn)
          item.show(0);
      }

    });
  }

}