// CardEx12.java
// Controls in split area 

package ch.aplu.cardex12;

import android.graphics.Color;
import ch.aplu.jcardgame.*;
import ch.aplu.android.*;

public class CardEx12 extends CardGame
{
  public enum Suit
  {
    SPADES, HEARTS, DIAMONDS, CLUBS
  }

  public enum Rank
  {
    ACE, KING, QUEEN, JACK, TEN, NINE, EIGHT, SEVEN, SIX
  }

  private Deck deck;
  private Hand talon;
  private Hand pile;

  public CardEx12()
  {
    super(Color.rgb(20, 80, 0), Color.WHITE, BoardType.HORZ_SPLIT, windowZoom(600));
  }

  public void main()
  {
    deck = new Deck(Suit.values(), Rank.values(), "cover");
    talon = deck.dealingOut(1, 9)[0];
    StackLayout talonLayout = new StackLayout(new Location(200, 300));
    talon.setView(this, talonLayout);
    talon.draw();
    pile = new Hand(deck);
    StackLayout pileLayout = new StackLayout(new Location(400, 300));
    pile.setView(this, pileLayout);
    pile.draw();

    final TextActor ta =
      new TextActor("Talon empty", Color.RED, Color.TRANSPARENT, 20);
    final Location loc = new Location(620, 580);  // Virtual loc

    double zCurrent = getZoomFactor();
    setZoomFactor(1);
    GGPushButton takeBtn = new GGPushButton("takebtn");
    setZoomFactor(zCurrent);  // Restore old zoom factor
    takeBtn.addPushButtonListener(
      new GGPushButtonAdapter()
      {
        public void buttonPressed(GGPushButton btn)
        {
          if (!talon.isEmpty())
          {
            Card top = talon.getLast();
            top.transfer(pile, true);
          }
          else
          {
            if (!ta.isVisible())
              addActor(ta, loc.toReal());
          }
        }

      });
    Location buttonLoc = new Location(300 + getVirtualPgWidth() / 2, 300);
    addActor(takeBtn, buttonLoc.toReal());

  }

}