// MovingPuck.java

package ch.aplu.movingpuck;

import ch.aplu.android.*;
import android.graphics.*;    

public class MovingPuck extends GameGrid
{
  protected final double courtSize = 10; // m
  protected double ballRadius;
  protected GGComboSensor sensor;
  protected GGPanel p;

  public MovingPuck()
  {
    super(WHITE, windowZoom(600));
  }

  public void main()
  {
    // Coordinate system in user coordinates, origin in court center
    p = getPanel(-courtSize / 2, courtSize / 2, 0.5);
    p.setAutoRefreshEnabled(false);
    setSimulationPeriod(50);
    ballRadius = p.toUserDx(virtualToPixel(20)); // Ball sprite radius 20 px
    p.clear(DKGRAY);
    sensor = GGComboSensor.init(this);
    p.setPaintColor(Color.rgb(100, 20, 20));
    p.circle(new PointD(0, 0), 0.9 * courtSize / 2, true);
    p.setPaintColor(Color.WHITE);
    Puck puck = new Puck(this); 
    addActor(puck, new Location(getNbHorzCells() / 2, getNbVertCells() / 2));
    doRun();
  }
 
}

