// NxtRover.java

package ch.aplu.nxtagent;

import ch.aplu.android.*;
import ch.aplu.android.nxt.*;

public class NxtRover extends NxtRobot
{
  private NxtAgent gg;
  private Motor motorA = new Motor(MotorPort.A);
  private Motor motorB = new Motor(MotorPort.B);
  private LightSensor ls = new LightSensor();
  private final int linearSpeed = 15;
  private final int angularSpeed = 3; 
  
  public NxtRover(NxtAgent gg)
  {
    super(gg);
    this.gg = gg;
    addPart(motorA);
    addPart(motorB);
    addPart(ls);
  }

  public int getIntensity()
  {
    return ls.getValue();
  }

  public void stop()
  {
    gg.tf[7].setText("Last command: stop");
    motorA.stop();
    motorB.stop();
  }

  public void forward()
  {
    gg.tf[7].setText("Last command: forward");
    motorA.setSpeed(linearSpeed);
    motorB.setSpeed(linearSpeed);
    motorA.forward();
    motorB.forward();
  }

  public void backward()
  {
    gg.tf[7].setText("Last command: backward");
    motorA.setSpeed(linearSpeed);
    motorB.setSpeed(linearSpeed);
    motorA.backward();
    motorB.backward();
  }

  public void left()
  {
    gg.tf[7].setText("Last command: left");
    motorA.setSpeed(angularSpeed);
    motorB.setSpeed(angularSpeed);
    motorA.forward();
    motorB.backward();
  }

  public void right()
  {
    gg.tf[7].setText("Last command: right");
    motorA.setSpeed(angularSpeed);
    motorB.setSpeed(angularSpeed);
    motorA.backward();
    motorB.forward();
  }
}


