// Ex01.java
// Simple Pacman implementation

package ch.aplu.pacman;

import ch.aplu.android.*;

public class Pacman extends GameGrid
{
  private final static int nbHorzCells = 30;
  private final static int nbVertCells = 33;
  protected PacActor pacActor;
  private Ghost pinky;
  private Ghost blinky;
  protected PacGrid grid;

  public Pacman()
  {
    super(nbHorzCells, nbVertCells, cellZoom(20), BLUE);
    setScreenOrientation(PORTRAIT);
    addSoftButton(0, "Up");  // Must be done in ctor
    addSoftButton(1, "Dn");
    addSoftButton(2, "Lt");
    addSoftButton(3, "Rt");
  }

  public void main()
  {
    pacActor = new PacActor();
    pinky = new Ghost(this, 0);
    blinky = new Ghost(this, 1);
    grid = new PacGrid();

    setSimulationPeriod(60);
    GGBackground bg = getBg();
    drawGrid(bg);
    addActor(pacActor, new Location(14, 24));
    addSoftButtonListener(pacActor);
    pinky.setSlowDown(3);
    addActor(pinky, new Location(13, 15), Location.NORTH);
    blinky.setSlowDown(3);
    addActor(blinky, new Location(14, 15), Location.NORTH);
    doRun();

    // Loop to look for collision in the main thread
    // This makes it improbable that we miss a hit
    while (!(pinky.getLocation().equals(pacActor.getLocation()) ||
      blinky.getLocation().equals(pacActor.getLocation())))
        delay(10);
    pacActor.hide();
    addActor(new Actor("gameover"), new Location(15, 12));
    TextActor ta =
      new TextActor("Eaten pills: " + pacActor.getNbPills(), YELLOW, TRANSPARENT, 25);
    addActor(ta, new Location(5, 17));
    doPause();
  }

  private void drawGrid(GGBackground bg)
  {
    bg.clear(GRAY);
    bg.setPaintColor(BLACK);
    for (int y = 0; y < nbVertCells; y++)
    {
      for (int x = 0; x < nbHorzCells; x++)
      {
        Location location = new Location(x, y);
        int a = grid.getCell(location);
        if (a == 1 || a == 2)
          bg.fillCell(location, LTGRAY);
        if (a == 1)  // Pill
          bg.fillCircle(toPoint(location), 3);
      }
    }
  }
}
