// RaspiConsole.java

package ch.aplu.raspiconsole;

import ch.aplu.android.*;
import ch.aplu.android.raspi.*;

public class RaspiConsole extends GameGrid implements ConnectionListener
{
  private GGConsole c;
  private Robot robot = null;

  public void main()
  {
    c = GGConsole.init();
    c.println("hallo. Trying to connect to 192.168.0.4...");
    robot = new Robot(this, "192.168.0.4", false);
    if (!robot.connect())
    {
       c.println("Connection failed");
       return;
    }
    c.println("Connection established");   
    InfraredSensor ir = new InfraredSensor(InfraredSensor.IR_CENTER);
    Gear gear = new Gear();
    gear.forward();
    gear.setSpeed(30);
    gear.forward();
    while (robot.isConnected())
    {
      int v = ir.getValue();
      if (v == 1)
      {
        gear.backward(2000);
        gear.forward();
      }
      Tools.delay(100);
    }
    c.println("Program terminated");
  }

 
  public void notifyConnection(boolean connected)
  {
    c.println("notify: " + connected);
  }

}
