// RaspiEvent.java
// IR event check

package ch.aplu.raspievent;

import ch.aplu.android.*;
import ch.aplu.android.raspi.*;
import android.graphics.Color;

public class RaspiEvent extends GameGrid
  implements ConnectionListener, InfraredListener
{
  private GGConsole c;
  private final String ipAddress = "10.1.1.4";

  public void main()
  {
    c = GGConsole.init();
    c.println("Hallo... trying to connect to " + ipAddress + "...");
    Robot robot = new Robot(this, ipAddress, false);
    if (!robot.connect())
    {
      c.println("Connection failed");
      return;
    }
    c.println("Connection established");
    InfraredSensor ir = new InfraredSensor(InfraredSensor.IR_CENTER);
    ir.addInfraredListener(this);
  }

  public void notifyConnection(boolean connected)
  {
    c.println("notify: " + connected);
  }

  public void activated(int id)
  {
    c.println("activated");
  }

  public void passivated(int id)
  {
    c.println("passivated");
  }
}
