// NxtRemoteTemp.java

package ch.aplu.remotetemp;

import ch.aplu.remotetemp.TemperatureSensor;
import ch.aplu.android.*;
import ch.aplu.android.nxt.*;

public class NxtRemoteTemp extends GameGrid 
{  
  private NxtRobot robot;
  private final int securityLevel = 25;  // Degrees
  private final int delayTime = 2000;  // ms
  
  public void main()
  {
    GGConsole c = GGConsole.init();
    c.println("NxtTempSensor starting");
    robot = new NxtRobot(c.getActivity());
    robot.connect();
    if (!robot.isConnected())
    {
      c.println("Connection to robot failed.");
      return;
    }
    c.println("Connnection established.");
    c.println("Remote Temperature:");
    TemperatureSensor ts = new TemperatureSensor(SensorPort.S1);
    robot.addPart(ts);
    int time = 0;
    while (true)  // Will be terminated by an exception in delay()
    {
      double value = ts.getDegrees();
      c.println(String.format("At %5d s: %5.1f degrees", time / 1000, value));
      if (value > securityLevel)
      {
        c.println("  Temperature too high");
        playTone(1000, 200);
      }
      delay(delayTime);
      time += delayTime;
    }
  }
  
   public void onPause()
   {
     if (robot != null)
       robot.exit();
     super.onPause();
   }
}