// SensorOrientation.java
// GGComboSensor: Azimuth, pitch, roll (old Android sensor API)
// Device rotation adapted

package ch.aplu.sensor.orientation;

import android.graphics.Typeface;
import ch.aplu.android.*;

public class SensorOrientation extends GameGrid
{
  private final int nbLines = 8;
  private GGTextField[] lines = new GGTextField[nbLines];

  public SensorOrientation()
  {
    super(WHITE);
  }

  public void main()
  {
    setWakeLockEnabled(true);
    initDisplay();
    showLegend1("*: Rot adapted");
    showLegend2("Rot: " + getRotation());
    GGComboSensor comboSensor = GGComboSensor.init(this);
    while (true)
    {
      float[] values = comboSensor.getOrientation(1);
      showValue(0, "azimuth", values[0], "deg");
      showValue(1, "pitch", values[1], "deg");
      showValue(2, "roll", values[2], "deg");
      showValue(3, "*azimuth", values[3], "deg");
      showValue(4, "*pitch", values[4], "deg");
      showValue(5, "*roll", values[5], "deg");
      refresh();
    }
  }

 private void initDisplay()
  {
    int dist = getNbVertCells() / (nbLines +1);
    for (int i = 0; i < nbLines; i++)
    {
      lines[i] =
        new GGTextField(new Location(10, (i + 1) * dist), false);
      lines[i].setFontSize(getNbHorzCells() / 15);
      lines[i].setTypeface(Typeface.MONOSPACE);
      lines[i].show();
    }
  }

  private void showLegend1(String text)
  {
    lines[6].setText(text);
  }

  private void showLegend2(String text)
  {
    lines[7].setText(text);
  }

  private void showValue(int line, String text, double value, String unit)
  {
    lines[line].setText(String.format(text + " = % 5.1f " + unit, value));
  }
  
}
