// SpaceShip.java
// Used for SpaceInvader

package ch.aplu.spaceinvader;

import ch.aplu.android.*;
import android.graphics.*;

public class SpaceShip extends Actor implements GGNavigationListener
{
  private int nbShots = 0;
  private SpaceInvader app;
  
  public SpaceShip(SpaceInvader app)
  {
    super("spaceship");
    this.app = app;
  }

  public void act()
  {
    GameGrid gg = gameGrid;
    Location location = getLocation();
    if (gg.getNumberOfActorsAt(location, Alien.class) > 0)  // Spaceship hit
    {
      gg.removeAllActors();
      gg.addActor(new Actor("explosion2"), location);
      gg.getBg().drawText("Press 'BACK' to play again", new Point(30, 50));
      gg.doPause();
      return;
    }
    if (gg.getNumberOfActors(Alien.class) == 0) // All aliens dead
    {
      gg.removeAllActors();
      gg.getBg().drawText("Game over. You survive.", new Point(30, 10));
      gg.getBg().drawText("Number of shots: " + nbShots, new Point(30, 30));
      gg.getBg().drawText("Press 'BACK' to play again", new Point(30, 50));
      gg.doPause();
    }
  }

  public void navigationEvent(GGNavigationEvent event)
  {
    switch (event)
    {
      case VOLUME_INCREASE_REPEAT:
        setDirection(Location.WEST);
        if (getX() > 5)
          move(SpaceInvader.dx);
        break;
      case VOLUME_DECREASE_REPEAT:
        setDirection(Location.EAST);
        if (getX() < SpaceInvader.nbHorzCells - 5)
          move(SpaceInvader.dx);
        break;
      case MENU_DOWN:
        Bomb bomb = new Bomb();
        gameGrid.addActor(bomb, getLocation());
        nbShots++;
        break;
      case BACK_DOWN:
        app.doPause();
        app.init();
        break;
  
    }
  }
}
