// Token.java

package ch.aplu.tcpfourinarow;

import android.graphics.Point;
import ch.aplu.android.*;


class Token extends Actor
{
  private TcpFourInARow gg;
  private Player player;
  private int nb = 0;

  public Token(TcpFourInARow gg, Player player)
  {
    super("token", 2);
    this.gg = gg;
    this.player = player;
    show(player == Player.RED ? 1 : 0);
    setActEnabled(false);
  }

  public void act()
  {
    Location nextLoc = new Location(getX(), getY() + 1);
    if (gameGrid.getOneActorAt(nextLoc, Token.class) == null && isMoveValid())
    {
      // For smooth drop animation
      if (nb == 6)
      {
        nb = 0;
        setLocationOffset(new Point(0, 0));
        move();
      }
      else
        setLocationOffset(new Point(0, 10 * nb));
      nb++;
    }
    else
    {
      setActEnabled(false);
      gg.tokenArrived(getLocation(), player);
    }
  }
}



