// TicTacToe.java

package ch.aplu.tictactoe;

import ch.aplu.android.*;

public class TicTacToe extends GameGrid
{
  private final String VERSION = "1.1";
  private final String sessionIDPrefix = "TicTacToe_67%&%2134";
  private final String bridgeName = "TicTacToeServer";
  protected GGStatusBar status;

  public TicTacToe()
  {
    super(3, 3, 80, BLUE);
    status = addStatusBar(20);
  }

  protected void clear()
  {
    removeAllActors();
  }

  public void main()
  {
    doRun(); // To perform automatic refresh
    getBg().clear(LTGRAY);
    String sessionID = getSessionID();
    if (sessionID == null)
    {
       status.setBackgroundColor(RED);
       status.setText("Game canceled");
    }
     else
       new Player(this, sessionID, bridgeName);
  }

  private String getSessionID()
  {
    String roomID = "";
    while (roomID.length() < 3)
    {
      roomID = GGInputDialog.show("TicTacToe V" + VERSION, 
        "Enter unique game room name (more than 2 characters):", "");
      if (roomID == null)  // Cancel
        return null;
      roomID = roomID.trim();
    }
    return sessionIDPrefix + roomID;
  }
}
